var saveCatTemplate = '<?xml version="1.0"?>' +
'<uzcardsort>' +
'<user/>' +
'<project/>' +
'<categories/>' + 
'</uzcardsort>';


function doSave() {
	var myList, myListName, myListItem, offset, listObject;
	var arCategories = new Array(1);
	for(var i=0;i<projectInfo.numcats;i++) {
		offset = i+1;
		arCategories[i] = new Object();
		listObject = arCategories[i];
		myList = document.getElementById("dropcat" + offset + "list");
		myListName = document.getElementById("dropcat" + offset + "name");
		listObject.name = myListName.value;
		listObject.vals = new Array();
		for(var j=0;j<myList.childNodes.length;j++) {
			myListItem = myList.childNodes.item(j);
			listObject.vals[j] = myListItem.getAttribute("label");
			
			dump("collating " + 	myListItem.getAttribute("label") + " in " + myListName.value + "\n");	
		}
	}
	createXML(arCategories);
}

function createXML(categories) {
	dump("Prepping XML\n\n");
	categoryXML =  new DOMParser().parseFromString(saveCatTemplate, "text/xml");
	var tempCatNode, tempItemNode, curCat, tempProjectNode;
	var categoriesNode = categoryXML.getElementsByTagName("categories").item(0);
	dump("Processing " +categories.length + " \n");
	
	tempProjectNode = categoryXML.getElementsByTagName("project").item(0);
	
	for(var h in projectInfo) {
		tempProjectNode.setAttribute(h, projectInfo[h]);
	}
	
	var objXMLSerializer = new XMLSerializer;
    
    //get the XML string
    dump( objXMLSerializer.serializeToString(categoriesNode));
	
	for(var i=0; i<categories.length;i++) {
		curCat = categories[i];
		tempCatNode = document.createElement("category");
		tempCatNode.setAttribute("label",  curCat.name);
		for(var j=0;j<curCat.vals.length;j++) {
			tempItemNode = document.createElement("item");
			tempItemNode.setAttribute("label",curCat.vals[j]);
			tempCatNode.appendChild(tempItemNode);
		}
		categoriesNode.appendChild(tempCatNode);
	}

	saveProject(categoryXML);
}

function saveProject() {
	var objXMLSerializer = new XMLSerializer;
    //get the XML string
	var sortData = objXMLSerializer.serializeToString(categoryXML);
    //dump("\n\n" + sortData + "\n\n" );

	var du=new DirUtils(); 
	var tempCat, tempCatName;
	var tempNode, tempLabel;
	var dataPath = du.getChromeDir() + fileSeparator + 'uzcardsort' + fileSeparator + 'content' + fileSeparator + 'data' + fileSeparator + projectInfo.name;
	var dataFolder = new Dir(dataPath);
	if(!dataFolder.exists()) dataFolder.create();
	dump("Found datafolder? " + dataPath + " "+ dataFolder.exists() + "\n");	
	dump(new Date().getTime() + "\n");
	var fileName = dataPath + fileSeparator + new Date().getTime() + '.xml';
	dump("filename is " + fileName + "\n");
	var dataFile = new File(fileName);
	dataFile.create();
	dataFile.open("w", 777);
	dataFile.write(sortData);
	dataFile.close();
	dump("Data saved.\n");
	alert("Thanks for participating.")
	window.close();
}

function doCatSortUnLoad() {

}